package dao;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import entity.Student;
import util.JdbcUtil;
public class StudentDao {
   //ѧ¼ķadd()
   public void add(Student student) throws Exception{
	 Connection conn = null;
	 PreparedStatement ps = null;
	 try {
		 conn = JdbcUtil.getConnection();
		 String sql = "insert into student  values (?,?,?) ";
		 ps = conn.prepareStatement(sql);
		 ps.setString(1, student.getSno());
		 ps.setString(2,student.getSname());
		 ps.setString(3,student.getSex());
		 ps.executeUpdate();
	 }finally {JdbcUtil.free(null,ps, conn);}
   }
   //޸ѧ¼ķupdate()
   public void update(Student student) throws Exception{
	Connection conn = null;
	PreparedStatement ps = null;
	try {
		conn = JdbcUtil.getConnection();
		String sql = "update student set sname=?,sex=? where sno=? ";
		ps = conn.prepareStatement(sql);
		ps.setString(1,student.getSname());
		ps.setString(2,student.getSex());
		ps.setString(3, student.getSno());
		ps.executeUpdate();
	}finally {JdbcUtil.free(null,ps, conn);}
   }
   //ɾѧ¼ķdelete()
   public void delete(String sno) throws Exception{
	 Connection conn = null;
	 PreparedStatement ps = null;
	 try {
		conn = JdbcUtil.getConnection();
		String sql = "delete from student where sno=?";
		ps = conn.prepareStatement(sql);
		ps.setString(1,sno);
		ps.executeUpdate();
	}finally {JdbcUtil.free( null,ps, conn);}
   }
   //idѯѧķfindById()
   public Student findById(String sno) throws Exception{
	Connection conn = null;
	PreparedStatement ps = null;
	ResultSet rs = null;
	Student student=null;
	try {
		conn = JdbcUtil.getConnection();
		String sql = "select * from student where sno=? ";
		ps = conn.prepareStatement(sql);
		ps.setString(1, sno);
		rs=ps.executeQuery();
		if(rs.next()){
		   student=new Student();
		   student.setSno(rs.getString(1));
		   student.setSname(rs.getString(2));
		   student.setSex(rs.getString(3));
		}
	}finally {JdbcUtil.free(rs, ps, conn);}
	return student;
   }
   //ѯȫ¼ķquery()
   public List<Student>  query() throws Exception{
	Connection conn = null;
	PreparedStatement ps = null;
	ResultSet rs = null;
	List<Student> studentList=new ArrayList<Student>();
	try {
		conn = JdbcUtil.getConnection();
		String sql = "select * from student ";
		ps=conn.prepareStatement(sql);
		rs=ps.executeQuery();
		while(rs.next()){
		   Student student=new Student();
		   student.setSno(rs.getString(1));
		   student.setSname(rs.getString(2));
		   student.setSex(rs.getString(3));
		   studentList.add(student);
		}
	}finally {JdbcUtil.free(rs, ps, conn);}
	return studentList;
   }
}
